"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
exports.__esModule = true;
var Base = (function () {
    function Base(base) {
        if (base === void 0) { base = Base.base; }
        if (!Base.verifyBase(base)) {
            throw new Error("Invalid base set! Be aware of duplicates and illegal characters (`.`, `-`)");
        }
        this.base = base;
    }
    Base.verifyBase = function (base) {
        var e_1, _a;
        if (base.includes(".") || base.includes("-"))
            return false;
        var characters = [];
        try {
            for (var base_1 = __values(base), base_1_1 = base_1.next(); !base_1_1.done; base_1_1 = base_1.next()) {
                var item = base_1_1.value;
                if (characters.includes(item))
                    return false;
                characters.push(item);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (base_1_1 && !base_1_1.done && (_a = base_1["return"])) _a.call(base_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return true;
    };
    Base.encode = function (n, base) {
        if (base === void 0) { base = Base.base; }
        if (typeof n !== "number" || typeof n === "number" && n === NaN) {
            throw new Error("Value is not a number!");
        }
        var str = "";
        var prefix = "";
        if (n < 0) {
            prefix += "-";
            n *= -1;
        }
        if (n === 0)
            base[0];
        var nCopy = n;
        while (Math.floor(n) > 0) {
            str = base[Math.floor(n) % base.length] + str;
            n = Math.floor(Math.floor(n) / base.length);
        }
        if (nCopy - Math.floor(nCopy)) {
            var decimalString = (nCopy - Math.floor(nCopy)).toPrecision();
            decimalString = decimalString.substring(2, decimalString.length);
            var decimals = parseInt(decimalString);
            str += "." + Base.encode(decimals);
        }
        return prefix + str;
    };
    Base.decode = function (str, base) {
        if (base === void 0) { base = Base.base; }
        if (!Base.verifyBase(base))
            throw new Error("Invalid base set! Be aware of duplicates and illegal characters (`.`, `-`)");
        var isNegative = str.length >= 2 && str.substring(0, 1) === "-";
        var hasDecimals = str.length >= 3 && str.includes(".");
        var n = 0;
        var decimal = 0;
        isNegative ? str = str.substring(1, str.length) : null;
        if (hasDecimals) {
            var strings = str.split(".");
            str = strings.shift();
            var decimals = strings.join("");
            decimal = Base.decode(decimals);
            decimal = parseFloat("0." + decimal.toPrecision());
            if (isNegative)
                decimal *= -1;
        }
        for (var i = 0; i < str.length; i++) {
            var char = str.charAt(i);
            n += base.indexOf(char) * Math.pow(base.length, str.length - i - 1);
        }
        if (isNegative)
            n *= -1;
        return n + decimal;
    };
    Base.prototype.encode = function (n) {
        return Base.encode(n, this.base);
    };
    Base.prototype.decode = function (str) {
        return Base.decode(str, this.base);
    };
    Base.base = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ".split("");
    return Base;
}());
exports["default"] = Base;
